/* CM_macros.h
 *------------------------------------------------------------*
 * DESCRIPTION
 *	CMPSL macros to make error handling a little easier.
 *------------------------------------------------------------*
 * HISTORY
 * Spring 89, Fil Alleva (faa) Carnegie Mellon
 *	Created
 */

#ifndef _CM_MACROS_H_
#define _CM_MACROS_H_

/* CM_fopen
 *------------------------------------------------------------*
 */ 
#define CM_fopen(name,mode)	_CM_fopen((name),(mode),__FILE__,__LINE__)

/* CM_fopenp
 *------------------------------------------------------------*
 */ 
#define CM_fopenp(dirl,name,mode)    _CM_fopenp((dirl),(name),(mode),__FILE__,__LINE__)


/* CM_fread
 *------------------------------------------------------------*
 */ 
#define CM_fread(ptr,cnt,size,stream)			\
{							\
    int32 err;						\
    char mesg[256];					\
    if (cnt != (err = fread(ptr,size,cnt,stream))) {	\
	sprintf (mesg, "%s(%d): fread(,%d,%d,) on [%s] returned %d",\
		 __FILE__, __LINE__, size, cnt,		\
		 _CM_file_name(stream), err);		\
	perror (mesg);					\
	exit (-1);					\
    }							\
}

				
/* CM_calloc
 *------------------------------------------------------------*
 */ 
#define CM_calloc(cnt,size)	_CM_calloc((cnt),(size),__FILE__,__LINE__)


/* CM_2dcalloc
 *------------------------------------------------------------*
 */ 
#define CM_2dcalloc(rcnt,ccnt,size) _CM_2dcalloc((rcnt),(ccnt),(size),__FILE__,__LINE__)

				
/* CM_3dcalloc
 *------------------------------------------------------------*
 */ 
#define CM_3dcalloc(lcnt,rcnt,ccnt,size) \
			_CM_3dcalloc((lcnt),(rcnt),(ccnt),(size),__FILE_,__LINE__)

				
/* CM_recalloc
 *------------------------------------------------------------*
 */ 
#define CM_recalloc(ptr,cnt,size)     _CM_recalloc((ptr),(cnt),(size),__FILE__,__LINE__)


extern FILE *_CM_fopen();
extern FILE *_CM_fopenp();
extern FILE *_CM_file_name();

extern char *_CM_calloc();
extern char *_CM_2dcalloc();
extern char *_CM_3dcalloc();
extern char *_CM_recalloc();

#endif  _CM_MACROS_H_
